#pragma  once

#include <assert.h>
#include <tisudshl.h>

using namespace _DSHOWLIB_NAMESPACE;

class CContrastEnhancement: public _DSHOWLIB_NAMESPACE::FrameFilterImpl<CContrastEnhancement>
{

	public:
		CContrastEnhancement();
		static _DSHOWLIB_NAMESPACE::FilterInfo getStaticFilterInfo();

		// Parameter input and output methods
		tFilterError    setEnabled( bool bVal );
		tFilterError    getEnabled( bool &bVal );

		tFilterError    setLowerBound( long lVal );
		tFilterError    getLowerBound( long &lVal );

		tFilterError    setUpperBound( long lVal );
		tFilterError    getUpperBound( long &lVal );
		
		// Property dialog methods
		bool hasDialog() const;
		bool callDialog( HWND );
	protected:
		virtual void    getSupportedInputTypes( FrameTypeInfoArray& arr ) const ;
		virtual bool    getTransformOutputTypes( const FrameTypeInfo& in_type, FrameTypeInfoArray& out_types ) const;
		virtual bool    transform( const IFrame& src, IFrame& dest );

	private:
		bool m_bEnabled;			// This flag is used to enable and disable the filter.
		long m_lowerBound;			// The low boarder of the interval all pixel values are mapped to
		long m_upperBound;			// The high boarder of the interval all pixel values are mapped to
};

