// Created with IC Imaging Control 3 C# application wizard

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Diagnostics;

using TIS.Imaging;


namespace CursorOnICWindow
{
	/// <summary>
	/// Summary description for CursorOnICWindow.
	/// </summary>
	public class CursorOnICWindow : System.Windows.Forms.Form
	{
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.ToolBar toolBar1;
		private System.Windows.Forms.StatusBar statusBar1;
		private System.Windows.Forms.ImageList ToolBarImageList;
		private System.Windows.Forms.MenuItem menuItemSettings;
		private System.Windows.Forms.MenuItem menuItemImageSettings;
		private System.Windows.Forms.MenuItem menuItemLiveStart;
		private System.Windows.Forms.MenuItem menuItemLiveStop;
		private System.Windows.Forms.ToolBarButton tbSelectDevice;
		private System.Windows.Forms.ToolBarButton tbImageSettings;
		private System.Windows.Forms.ToolBarButton tbStartLive;
		private System.Windows.Forms.ToolBarButton tbStopLive;
		private System.Windows.Forms.StatusBarPanel sbDevicePanel;
		private System.Windows.Forms.StatusBarPanel sbVideoFormatPanel;
		private TIS.Imaging.ICImagingControl icImagingControl1;
		private System.ComponentModel.IContainer components;


		// In order to change the cursor on the IC Imaging Control window, we
		// need a small DLL that finds the matching IC Imaging Contro windows and
		// set the cursor. 
		// In the DLL the function "FindICWindow" is implemented, that receives
		// the handle of our application's window and the filename of the cursor
		// to be loaded.
		// When the application is compiled first time, the "icsetcursor.dll" and
		// the "cross.cur" must be copied manually into the "bin/debug" and "bin\release"
		// directory. Otherwise a "DLL not found" Exception is thrown.
		[System.Runtime.InteropServices.DllImport ("icsetcursor.dll")]
		private extern static long  FindICWindow(IntPtr ParentWindow, string szCursorName);

		public CursorOnICWindow()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(CursorOnICWindow));
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItemSettings = new System.Windows.Forms.MenuItem();
			this.menuItemImageSettings = new System.Windows.Forms.MenuItem();
			this.menuItemLiveStart = new System.Windows.Forms.MenuItem();
			this.menuItemLiveStop = new System.Windows.Forms.MenuItem();
			this.toolBar1 = new System.Windows.Forms.ToolBar();
			this.tbSelectDevice = new System.Windows.Forms.ToolBarButton();
			this.tbImageSettings = new System.Windows.Forms.ToolBarButton();
			this.tbStartLive = new System.Windows.Forms.ToolBarButton();
			this.tbStopLive = new System.Windows.Forms.ToolBarButton();
			this.ToolBarImageList = new System.Windows.Forms.ImageList(this.components);
			this.statusBar1 = new System.Windows.Forms.StatusBar();
			this.sbDevicePanel = new System.Windows.Forms.StatusBarPanel();
			this.sbVideoFormatPanel = new System.Windows.Forms.StatusBarPanel();
			this.icImagingControl1 = new TIS.Imaging.ICImagingControl();
			((System.ComponentModel.ISupportInitialize)(this.sbDevicePanel)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.sbVideoFormatPanel)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.icImagingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItemSettings,
																					  this.menuItemImageSettings,
																					  this.menuItemLiveStart,
																					  this.menuItemLiveStop});
			this.menuItem1.Text = "Device";
			// 
			// menuItemSettings
			// 
			this.menuItemSettings.Index = 0;
			this.menuItemSettings.Text = "Open / setup device";
			this.menuItemSettings.Click += new System.EventHandler(this.menuItemSettings_Click);
			// 
			// menuItemImageSettings
			// 
			this.menuItemImageSettings.Enabled = false;
			this.menuItemImageSettings.Index = 1;
			this.menuItemImageSettings.Text = "Image Setting";
			this.menuItemImageSettings.Click += new System.EventHandler(this.menuItemImageSettings_Click);
			// 
			// menuItemLiveStart
			// 
			this.menuItemLiveStart.Enabled = false;
			this.menuItemLiveStart.Index = 2;
			this.menuItemLiveStart.Text = "Start live";
			this.menuItemLiveStart.Click += new System.EventHandler(this.menuItemLiveStart_Click);
			// 
			// menuItemLiveStop
			// 
			this.menuItemLiveStop.Enabled = false;
			this.menuItemLiveStop.Index = 3;
			this.menuItemLiveStop.Text = "Stop live";
			this.menuItemLiveStop.Click += new System.EventHandler(this.menuItemLiveStop_Click);
			// 
			// toolBar1
			// 
			this.toolBar1.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																						this.tbSelectDevice,
																						this.tbImageSettings,
																						this.tbStartLive,
																						this.tbStopLive});
			this.toolBar1.ButtonSize = new System.Drawing.Size(16, 16);
			this.toolBar1.DropDownArrows = true;
			this.toolBar1.ImageList = this.ToolBarImageList;
			this.toolBar1.Location = new System.Drawing.Point(0, 0);
			this.toolBar1.Name = "toolBar1";
			this.toolBar1.ShowToolTips = true;
			this.toolBar1.Size = new System.Drawing.Size(641, 28);
			this.toolBar1.TabIndex = 1;
			this.toolBar1.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar1_ButtonClick);
			// 
			// tbSelectDevice
			// 
			this.tbSelectDevice.ImageIndex = 0;
			this.tbSelectDevice.ToolTipText = "Select Device";
			// 
			// tbImageSettings
			// 
			this.tbImageSettings.Enabled = false;
			this.tbImageSettings.ImageIndex = 1;
			this.tbImageSettings.ToolTipText = "Image Settings";
			// 
			// tbStartLive
			// 
			this.tbStartLive.Enabled = false;
			this.tbStartLive.ImageIndex = 2;
			this.tbStartLive.ToolTipText = "Start live video";
			// 
			// tbStopLive
			// 
			this.tbStopLive.Enabled = false;
			this.tbStopLive.ImageIndex = 3;
			this.tbStopLive.ToolTipText = "Stop live video";
			// 
			// ToolBarImageList
			// 
			this.ToolBarImageList.ImageSize = new System.Drawing.Size(16, 16);
			this.ToolBarImageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("ToolBarImageList.ImageStream")));
			this.ToolBarImageList.TransparentColor = System.Drawing.Color.Magenta;
			// 
			// statusBar1
			// 
			this.statusBar1.Location = new System.Drawing.Point(0, 504);
			this.statusBar1.Name = "statusBar1";
			this.statusBar1.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
																						  this.sbDevicePanel,
																						  this.sbVideoFormatPanel});
			this.statusBar1.ShowPanels = true;
			this.statusBar1.Size = new System.Drawing.Size(641, 22);
			this.statusBar1.TabIndex = 2;
			// 
			// sbDevicePanel
			// 
			this.sbDevicePanel.MinWidth = 200;
			this.sbDevicePanel.Text = "No video capture device opened.";
			this.sbDevicePanel.Width = 200;
			// 
			// icImagingControl1
			// 
			this.icImagingControl1.DeBayerMode = TIS.Imaging.DeBayerModes.Edgesensing;
			this.icImagingControl1.DeBayerStartPattern = TIS.Imaging.DeBayerStartPatterns.BG;
			this.icImagingControl1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.icImagingControl1.ImageRingBufferSize = 5;
			this.icImagingControl1.LiveDisplayHeight = 480;
			this.icImagingControl1.LiveDisplayWidth = 640;
			this.icImagingControl1.LiveShowLastBuffer = true;
			this.icImagingControl1.Location = new System.Drawing.Point(0, 28);
			this.icImagingControl1.Name = "icImagingControl1";
			this.icImagingControl1.OverlayBitmapPosition = TIS.Imaging.PathPositions.Device;
			this.icImagingControl1.SinkCompatibilityMode = true;
			this.icImagingControl1.Size = new System.Drawing.Size(641, 476);
			this.icImagingControl1.TabIndex = 3;
			// 
			// CursorOnICWindow
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(641, 526);
			this.Controls.Add(this.icImagingControl1);
			this.Controls.Add(this.statusBar1);
			this.Controls.Add(this.toolBar1);
			this.Menu = this.mainMenu1;
			this.Name = "CursorOnICWindow";
			this.Text = "Cursor On IC Imagingcontrol Window";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.CursorOnICWindow_Closing);
			this.Load += new System.EventHandler(this.CursorOnICWindow_Load);
			((System.ComponentModel.ISupportInitialize)(this.sbDevicePanel)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.sbVideoFormatPanel)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.icImagingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new CursorOnICWindow());

		}

		//////////////////////////////////////////////////////////////////////////
		
		/// <summary>
		/// CursorOnICWindow_Load
		/// 
		/// In the Load event of the application the cursor is set to IC Imaging Control
		/// first time. 
		/// After the live video has been started, the cursor must be set again,
		/// because the display of the live video is done in another window.
		/// 
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void CursorOnICWindow_Load(object sender, System.EventArgs e)
		{

			// Try to load the previously used device. 
			try
			{
				icImagingControl1.LoadDeviceStateFromFile("device.xml",true);
				if( icImagingControl1.DeviceValid  )
				{
					// Enable the menu and toolbar controls.
					EnableControls(true);
					// Display the current device and video format in the statusbar.
					sbDevicePanel.Text = icImagingControl1.Device;
					sbVideoFormatPanel.Text = icImagingControl1.VideoFormat;
				}
			}catch{}
			try
			{
				// Set the cursor.
				FindICWindow(this.Handle,"cross.cur");
			}
			catch
			{
				// In order to avoid the application stops in case the "icsetcursor.dll" is
				// missing, the application catches the "DLL not found" exception.
				MessageBox.Show("The DLL \"icsetcursor.dll\" was not found.\nPlease make sure it is saved in your working directory!","Set Cursor");
			}
		}

		/// <summary>
		/// Stop the live video stream, if the application is closed.
		/// </summary>
		private void CursorOnICWindow_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if( icImagingControl1.DeviceValid )
			{
				icImagingControl1.LiveStop();
			}
		}

		/// <summary>
		/// Show the device selection dialog of IC Imaging Control.
		/// </summary>
		private void OpenNewVideoCaptureDevice()
		{
			tbStopLive.Enabled = false;

			if( icImagingControl1.DeviceValid )
			{
				icImagingControl1.LiveStop();
			}
			EnableControls( false ); // Disable the controls.
			icImagingControl1.ShowDeviceSettingsDialog();
			if( icImagingControl1.DeviceValid  )
			{
				// Save the currently used device into a file in order to be able to open it
				// automatically at the next program start.
				icImagingControl1.SaveDeviceStateToFile("device.xml");
				// Enable the menu and toolbar controls.
				EnableControls(true);
				// Display the current device and video format in the statusbar.
				sbDevicePanel.Text = icImagingControl1.Device;
				sbVideoFormatPanel.Text = icImagingControl1.VideoFormat;
			}
		}
		
		/// <summary>
		/// Update the controls in the toolbar and the menu, according
		/// to the device state.
		/// </summary>
		/// <param name="bEnable"></param>
		private void EnableControls( bool bEnable)
		{
			menuItemImageSettings.Enabled = bEnable;
			menuItemLiveStop.Enabled = bEnable;
			menuItemLiveStart.Enabled = bEnable;

			tbImageSettings.Enabled = bEnable;
			tbStartLive.Enabled = bEnable;

			sbDevicePanel.Text = "";
			sbVideoFormatPanel.Text = "";
		}

		/// <summary>
		/// Start the live video and update the state of the start/stop buttons.
		/// 
		/// The cursor must set here again.
		/// </summary>
		private void StartLiveVideo()
		{
			icImagingControl1.LiveStart();
			menuItemLiveStart.Enabled = false;
			menuItemLiveStop.Enabled = true;

			tbStartLive.Enabled = false;
			tbStopLive.Enabled = true;

			// Set the cursor to the live video's display window.
			FindICWindow(this.Handle,"cross.cur");
		}
		/// <summary>
		/// Stop the live video and update the state of the start/stop buttons.
		/// </summary>
		private void StopLiveVideo()
		{
			icImagingControl1.LiveStop();
			menuItemLiveStart.Enabled = true;
			menuItemLiveStop.Enabled = false;
			tbStartLive.Enabled = true;
			tbStopLive.Enabled = false;
		}

		/// <summary>
		/// Show the image settings dialog for exposure, brightness etc. The 
		/// changes that were made using the dialog are saved to the file 'device.xml'.
		/// </summary>
		private void ShowImageSettingsDialog()
		{
			if( icImagingControl1.DeviceValid == true )
			{
				icImagingControl1.ShowPropertyDialog();
				icImagingControl1.SaveDeviceStateToFile("device.xml");
			}
		}

		/// <summary>
		/// Messagehandler for the menu and the toolbar.
		/// </summary>
		private void menuItemSettings_Click(object sender, System.EventArgs e)
		{
			OpenNewVideoCaptureDevice();	
		}

		private void menuItemImageSettings_Click(object sender, System.EventArgs e)
		{
			ShowImageSettingsDialog();
		}

		private void menuItemLiveStart_Click(object sender, System.EventArgs e)
		{
			StartLiveVideo();
		}

		private void menuItemLiveStop_Click(object sender, System.EventArgs e)
		{
			StopLiveVideo();
		}

		private void toolBar1_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			switch (toolBar1.Buttons.IndexOf(e.Button))
			{
				case 0: OpenNewVideoCaptureDevice();
						break;
				case 1: ShowImageSettingsDialog();
						break;
				case 2: StartLiveVideo();
						break;
				case 3: StopLiveVideo();
						break;
			}
		}

	}
}
