using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Image_Processing___Binarization
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private TIS.Imaging.ICImagingControl icImagingControl1;
		private System.Windows.Forms.Button btnSnapImage;
		private System.Windows.Forms.Button btnBinarize;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox txtThreshold;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.icImagingControl1 = new TIS.Imaging.ICImagingControl();
			this.btnSnapImage = new System.Windows.Forms.Button();
			this.btnBinarize = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.txtThreshold = new System.Windows.Forms.TextBox();
			((System.ComponentModel.ISupportInitialize)(this.icImagingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// icImagingControl1
			// 
			this.icImagingControl1.DeBayerMode = TIS.Imaging.DeBayerModes.Edgesensing;
			this.icImagingControl1.DeBayerStartPattern = TIS.Imaging.DeBayerStartPatterns.BG;
			this.icImagingControl1.ImageRingBufferSize = 5;
			this.icImagingControl1.LiveDisplayHeight = 480;
			this.icImagingControl1.LiveDisplayWidth = 640;
			this.icImagingControl1.LiveShowLastBuffer = true;
			this.icImagingControl1.Location = new System.Drawing.Point(8, 8);
			this.icImagingControl1.Name = "icImagingControl1";
			this.icImagingControl1.OverlayBitmapPosition = TIS.Imaging.PathPositions.Device;
			this.icImagingControl1.Size = new System.Drawing.Size(432, 304);
			this.icImagingControl1.TabIndex = 0;
			// 
			// btnSnapImage
			// 
			this.btnSnapImage.Location = new System.Drawing.Point(8, 320);
			this.btnSnapImage.Name = "btnSnapImage";
			this.btnSnapImage.Size = new System.Drawing.Size(96, 24);
			this.btnSnapImage.TabIndex = 1;
			this.btnSnapImage.Text = "Snap Image";
			this.btnSnapImage.Click += new System.EventHandler(this.btnSnapImage_Click);
			// 
			// btnBinarize
			// 
			this.btnBinarize.Enabled = false;
			this.btnBinarize.Location = new System.Drawing.Point(344, 320);
			this.btnBinarize.Name = "btnBinarize";
			this.btnBinarize.Size = new System.Drawing.Size(96, 24);
			this.btnBinarize.TabIndex = 2;
			this.btnBinarize.Text = "Binarize";
			this.btnBinarize.Click += new System.EventHandler(this.btnBinarize_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(200, 320);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(56, 23);
			this.label1.TabIndex = 3;
			this.label1.Text = "Threshold";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// txtThreshold
			// 
			this.txtThreshold.Location = new System.Drawing.Point(264, 320);
			this.txtThreshold.Name = "txtThreshold";
			this.txtThreshold.Size = new System.Drawing.Size(72, 20);
			this.txtThreshold.TabIndex = 4;
			this.txtThreshold.Text = "128";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(448, 350);
			this.Controls.Add(this.txtThreshold);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.btnBinarize);
			this.Controls.Add(this.btnSnapImage);
			this.Controls.Add(this.icImagingControl1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.Name = "Form1";
			this.Text = "Image Processing - Binarization";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.icImagingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
		
		private void Form1_Load(object sender, System.EventArgs e)
		{
			icImagingControl1.ShowDeviceSettingsDialog();

			if( !icImagingControl1.DeviceValid )
			{
				Close();
				return;
			}

			icImagingControl1.MemoryCurrentGrabberColorformat = TIS.Imaging.ICImagingControlColorformats.ICY800;
			icImagingControl1.LiveDisplay = false;
			icImagingControl1.LiveStart();
		}
		private void btnSnapImage_Click(object sender, System.EventArgs e)
		{
			icImagingControl1.MemorySnapImage();
			icImagingControl1.Display();

			btnBinarize.Enabled = true;
		}
		private void btnBinarize_Click(object sender, System.EventArgs e)
		{
			int threshold = int.Parse( txtThreshold.Text );
			if( threshold < 0 || threshold > 255 )
			{
				MessageBox.Show( "Invalid threshold value", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error	);
			}

			TIS.Imaging.ImageBuffer ib = icImagingControl1.ImageActiveBuffer;

			for( int y = 0; y < ib.Lines; ++y )
			{
				for( int x = 0; x < ib.PixelPerLine; ++x )
				{
					if( ib[x,y] < threshold )
						ib[x,y] = 0;
					else
						ib[x,y] = 255;
				}
			}

			icImagingControl1.Display();
		}
	}
}
